precision highp float;

uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;

uniform float whites;
uniform float blacks;

float o(in vec3 a){
    const vec3 b = vec3(.298839, .586811, .11435);
    return dot(a, b);
}

vec3 Y(in vec3 a){
    float b = o(a);
    float c = min(min(a.r, a.g), a.b);
    float d = max(max(a.r, a.g), a.b);
    if (c < 0.) a = (a - b) * b / (b - c) + b;
    if (d > 1.) a = (a - b) * (1. - b) / (d - b) + b;
    return a;
}

vec3 R(in vec3 a, in float b){
    float c = b - o(a);
    return Y(a + c);
}

vec3 applyBlacksNWhites(vec3 k, float i, float j){
    vec3 d = k;
    const float l = -6.994413;
    const float n = -.188103;
    const float p = -14.950968;
    const float q = -34.330249;
    const float r = -3.418496;
    const float s = -12.099387;
    const float x = -2.919341;
    const float y = -9.767371;
    const float G = -121.21509;
    const float H = -108.566087;

    float I = max(d.r, max(d.g, d.b));
    float J = min(d.r, min(d.g, d.b));

    float b = (I + J) / 2.;
    float h = b;
    float a = h * h;
    float c = a * h;

    vec3 e;
    float f, g;
    f = .005337 * h + .666424 * a + 3.023761 * c + l * a * a + 3.293987 * a * c;
    f = min(f, 1. - b);
    g = n * h + 2.812945 * a + p * c + 33.494165 * a * a + q * a * c + 13.143082 * c * c;
    g = max(g, -b);
    e = i >= 0. ? d * (f * i + b) / b : d * (b - g * i) / b;
    e = clamp(e, 0., 1.);
    f = .837673 * h + r * a + 8.078055 * c + s * a * a + 9.520316 * a * c + x * c * c;
    f = min(f, 1. - b);
    g = b <= .23 ? -b : .508865 + y * h + 49.107057 * a + G * c + 160.620531 * a * a + H * a * c + 29.315822 * c * c;
    g = max(g, -b);
    e = j >= 0. ? e * (f * j + b) / b : e * (b - g * j) / b;
    e = clamp(e, 0., 1.);
    k = R(d, o(e));
    return k;
}

void main(){
    lowp vec4 src = texture2D(inputImageTexture, textureCoordinate);
    src.rgb = applyBlacksNWhites(src.rgb, whites, blacks);
    gl_FragColor = vec4(src.rgb, src.a);
}