precision mediump float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform lowp float intensity;

void main() {
    vec3 lum = vec3(0.299, 0.587, 0.114);
    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    vec3 p =  vec3(pow(color.r,2.0), pow(color.g,2.0), pow(color.b,2.0));
    float luminance = sqrt( dot(p, lum));
    float highlights = intensity * 0.05 * ( pow(8.0, luminance) - 1.0 );
    color += highlights;
    gl_FragColor = color;
}