precision mediump float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform lowp float mip;
uniform highp vec2 resolution;


vec3 jodieRobo2(const vec3 d) {
    float c=dot(d,vec3(.2126,.7152,.0722));
    vec4 e=vec4(d,c)*inversesqrt(c*c+1.);
    vec3 a=e.rgb;
    float b=e.a;
    float f=max(max(max(e.r,e.g),e.b),1.);
    return (b*a-a-(f*b-b))/(b-f);
}

vec3 tpow(vec2 p, float m) {
    return pow(texture2D(inputImageTexture,p,m).rgb,vec3(2.2));
}

vec3 fastBloom (vec2 p, vec2 r){
    float scale = exp2(mip);
    vec3 c =
    tpow((p+vec2(-1.5,-0.5)*scale)/r,mip) *.1 +
    tpow((p+vec2( 0.5,-1.5)*scale)/r,mip) *.1 +
    tpow((p+vec2( 1.5, 0.5)*scale)/r,mip) *.1 +
    tpow((p+vec2(-0.5, 1.5)*scale)/r,mip) *.1 +
    tpow((p)/r,mip) * .7 +
    tpow(p/r,0.) * .7;
    return c;
}

void main() {
    vec3 color = fastBloom(gl_FragCoord.xy, resolution.xy);
    color = jodieRobo2(color);
    vec4 bloompow = vec4(pow(color,vec3(1.0/2.15)), 1.0);
    gl_FragColor = bloompow;
}