precision highp float;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float vibrance;
uniform float opacity;

varying vec2 textureCoordinate;

float overlay_ch(float bg, float fg) {
    return bg < 0.5 ? (2.0 * bg * fg) : (1.0 - 2.0 * (1.0 - bg) * (1.0 - fg));
}

vec3 overlay(vec3 bg, vec3 fg) {
    return vec3(overlay_ch(bg.r, fg.r), overlay_ch(bg.g, fg.g), overlay_ch(bg.b, fg.b));
}

void main()
{
    vec4 src = texture2D(inputImageTexture, textureCoordinate);
    vec3 trg = texture2D(inputImageTexture2, textureCoordinate).rgb;

    float alpha = src.a;
    vec3 color  = mix(src.rgb, overlay(src.rgb, trg), vibrance * opacity);

    gl_FragColor = vec4(color, alpha);
}