precision highp float;

uniform sampler2D inputImageTexture;
uniform vec4 shadowColor;
uniform float opacity;
uniform int showShadow;

varying highp vec2 textureCoordinate;

void main()
{
    if (showShadow == 0){
        gl_FragColor = vec4(0.0);
        return;
    }

    lowp vec4 person =  texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 fragmentShadowColor = shadowColor;

    fragmentShadowColor *= person.a;
    fragmentShadowColor *= opacity;

    gl_FragColor = fragmentShadowColor;
}
