precision highp float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform highp float sharpness;
uniform highp vec2 resolution;

void main() {

    vec2 uv = gl_FragCoord.xy / resolution.xy;
    uv.x = mod( uv.x , 1.0 );
    vec2 step = 1.0 / resolution.xy;

    vec3 texA = texture2D( inputImageTexture, uv + vec2(-step.x, -step.y) * 1.1 ).rgb;
    vec3 texB = texture2D( inputImageTexture, uv + vec2( step.x, -step.y) * 1.1 ).rgb;
    vec3 texC = texture2D( inputImageTexture, uv + vec2(-step.x,  step.y) * 1.1 ).rgb;
    vec3 texD = texture2D( inputImageTexture, uv + vec2( step.x,  step.y) * 1.1 ).rgb;

    vec3 around = 0.25 * (texA + texB + texC + texD);
    vec3 center  = texture2D( inputImageTexture, uv ).rgb;

    vec3 col = center + (center - around) * sharpness;
    gl_FragColor = vec4(col, 1.0);
}