varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform lowp float scalex;
uniform lowp float scaley;

void main()
{
    highp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    highp vec4 overlay = texture2D(inputImageTexture2, vec2(textureCoordinate.x * scalex, textureCoordinate.y * scaley));

    mediump float ra = (overlay.a) * overlay.r + (1.0 - overlay.a) * base.r;
    mediump float ga = (overlay.a) * overlay.g + (1.0 - overlay.a) * base.g;
    mediump float ba = (overlay.a) * overlay.b + (1.0 - overlay.a) * base.b;

    gl_FragColor = base;
}